2 # This Makefile fragment tries to be general-purpose enough to be
3 # used by many projects via the gnulib maintainer-makefile module.
5 ## Copyright (C) 2001-2012 Free Software Foundation, Inc.
7 ## This program is free software: you can redistribute it and/or modify
8 ## it under the terms of the GNU General Public License as published by
9 ## the Free Software Foundation, either version 3 of the License, or
10 ## (at your option) any later version.
12 ## This program is distributed in the hope that it will be useful,
13 ## but WITHOUT ANY WARRANTY; without even the implied warranty of
14 ## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
15 ## GNU General Public License for more details.
17 ## You should have received a copy of the GNU General Public License
18 ## along with this program. If not, see <http://www.gnu.org/licenses/>.
20 # This is reported not to work with make-3.79.1
21 # ME := $(word $(words $(MAKEFILE_LIST)),$(MAKEFILE_LIST))
24 # Diagnostic for continued use of deprecated variable.
28 set $$(_build-aux) relative to $$(srcdir) instead of $$(build_aux)")
31 # Do not save the original name or timestamp in the .tar.gz file.
32 # Use --rsyncable if available.
34 $(shell gzip
--help
2>/dev
/null|grep rsyncable
>/dev
/null \
35 && printf
%s
--rsyncable
)
36 GZIP_ENV
= '--no-name --best $(gzip_rsyncable)'
41 VC_LIST
= $(srcdir)/$(_build-aux
)/vc-list-files
-C
$(srcdir)
43 # You can override this variable in cfg.mk to set your own regexp
44 # matching files to ignore.
45 VC_LIST_ALWAYS_EXCLUDE_REGEX ?
= ^
$$
47 # This is to preprocess robustly the output of $(VC_LIST), so that even
48 # when $(srcdir) is a pathological name like "....", the leading sed command
49 # removes only the intended prefix.
50 _dot_escaped_srcdir
= $(subst .
,\.
,$(srcdir))
52 # Post-process $(VC_LIST) output, prepending $(srcdir)/, but only
53 # when $(srcdir) is not ".".
55 _prepend_srcdir_prefix
=
57 _prepend_srcdir_prefix
= | sed
's|^|$(srcdir)/|'
60 # In order to be able to consistently filter "."-relative names,
61 # (i.e., with no $(srcdir) prefix), this definition is careful to
62 # remove any $(srcdir) prefix, and to restore what it removes.
64 $(or
$(exclude_file_name_regexp--
$@
),^
$$)
66 $(VC_LIST
) | sed
's|^$(_dot_escaped_srcdir)/||' \
67 | if
test -f
$(srcdir)/.x-
$@
; then grep
-vEf
$(srcdir)/.x-
$@
; \
68 else grep
-Ev
-e
"$${VC_LIST_EXCEPT_DEFAULT-ChangeLog}"; fi \
69 | grep
-Ev
-e
'($(VC_LIST_ALWAYS_EXCLUDE_REGEX)|$(_sc_excl))' \
70 $(_prepend_srcdir_prefix
)
72 ifeq ($(origin prev_version_file
), undefined
)
73 prev_version_file
= $(srcdir)/.prev-version
76 PREV_VERSION
:= $(shell cat
$(prev_version_file
) 2>/dev
/null
)
77 VERSION_REGEXP
= $(subst .
,\.
,$(VERSION
))
78 PREV_VERSION_REGEXP
= $(subst .
,\.
,$(PREV_VERSION
))
81 this-vc-tag
= v
$(VERSION
)
82 this-vc-tag-regexp
= v
$(VERSION_REGEXP
)
84 tag-package
= $(shell echo
"$(PACKAGE)" | tr
'[:lower:]' '[:upper:]')
85 tag-this-version
= $(subst .
,_
,$(VERSION
))
86 this-vc-tag
= $(tag-package
)-$(tag-this-version
)
87 this-vc-tag-regexp
= $(this-vc-tag
)
89 my_distdir
= $(PACKAGE
)-$(VERSION
)
91 # Old releases are stored here.
92 release_archive_dir ?
= ..
/release
94 # Override gnu_rel_host and url_dir_list in cfg.mk if these are not right.
95 # Use alpha.gnu.org for alpha and beta releases.
96 # Use ftp.gnu.org for stable releases.
97 gnu_ftp_host-alpha
= alpha.gnu.org
98 gnu_ftp_host-beta
= alpha.gnu.org
99 gnu_ftp_host-stable
= ftp.gnu.org
100 gnu_rel_host ?
= $(gnu_ftp_host-
$(RELEASE_TYPE
))
102 ifeq ($(gnu_rel_host
),ftp.gnu.org
)
103 url_dir_list ?
= http
://ftpmirror.gnu.org
/$(PACKAGE
)
105 url_dir_list ?
= ftp
://$(gnu_rel_host
)/gnu
/$(PACKAGE
)
108 # Override this in cfg.mk if you are using a different format in your
110 today
= $(shell date
+%Y-
%m-
%d
)
112 # Select which lines of NEWS are searched for $(news-check-regexp).
113 # This is a sed line number spec. The default says that we search
114 # lines 1..10 of NEWS for $(news-check-regexp).
115 # If you want to search only line 3 or only lines 20-22, use "3" or "20,22".
116 news-check-lines-spec ?
= 1,10
117 news-check-regexp ?
= '^\*.* $(VERSION_REGEXP) \($(today)\)'
119 # Prevent programs like 'sort' from considering distinct strings to be equal.
120 # Doing it here saves us from having to set LC_ALL elsewhere in this file.
123 ## --------------- ##
125 ## --------------- ##
127 _cfg_mk
:= $(shell test -f
$(srcdir)/cfg.mk
&& echo
'$(srcdir)/cfg.mk')
129 # Collect the names of rules starting with 'sc_'.
130 syntax-check-rules
:= $(sort $(shell sed
-n
's/^\(sc_[a-zA-Z0-9_-]*\):.*/\1/p' \
131 $(srcdir)/$(ME
) $(_cfg_mk
)))
132 .PHONY
: $(syntax-check-rules
)
134 ifeq ($(shell $(VC_LIST
) >/dev
/null
2>&1; echo
$$?
),0)
135 local-checks-available
+= $(syntax-check-rules
)
137 local-checks-available
+= no-vc-detected
139 @echo
"No version control files detected; skipping syntax check"
141 .PHONY
: $(local-checks-available
)
143 # Arrange to print the name of each syntax-checking rule just before running it.
144 $(syntax-check-rules
): %: %.m
145 sc_m_rules_
= $(patsubst %, %.m
, $(syntax-check-rules
))
146 .PHONY
: $(sc_m_rules_
)
148 @echo
$(patsubst sc_
%.m
, %, $@
)
149 @date
+%s.
%N
> .sc-start-
$(basename $@
)
151 # Compute and print the elapsed time for each syntax-check rule.
152 sc_z_rules_
= $(patsubst %, %.z
, $(syntax-check-rules
))
153 .PHONY
: $(sc_z_rules_
)
154 $(sc_z_rules_
): %.z
: %
155 @end
=$$(date
+%s.
%N
); \
156 start
=$$(cat .sc-start-
$*); \
157 rm -f .sc-start-
$*; \
158 awk
-v s
=$$start -v e
=$$end \
159 'END {printf "%.2f $(patsubst sc_%,%,$*)\n", e - s}' < /dev
/null
161 # The patsubst here is to replace each sc_% rule with its sc_%.z wrapper
162 # that computes and prints elapsed time.
164 $(patsubst sc_
%, sc_
%.z
, \
165 $(filter-out $(local-checks-to-skip
), $(local-checks-available
)))
167 syntax-check
: $(local-check
)
171 # This macro searches for a given construct in the selected files and
172 # then takes some action.
174 # Parameters (shell variables):
178 # Regular expression (ERE) denoting either a forbidden construct
179 # or a required construct. Those arguments are exclusive.
183 # Regular expression (ERE) denoting lines to ignore that matched
184 # a prohibit construct. For example, this can be used to exclude
185 # comments that mention why the nearby code uses an alternative
186 # construct instead of the simpler prohibited construct.
188 # in_vc_files | in_files
190 # grep-E-style regexp selecting the files to check. For in_vc_files,
191 # the regexp is used to select matching files from the list of all
192 # version-controlled files; for in_files, it's from the names printed
193 # by "find $(srcdir)". When neither is specified, use all files that
194 # are under version control.
196 # containing | non_containing
198 # Select the files (non) containing strings matching this regexp.
199 # If both arguments are specified then CONTAINING takes
204 # Extra options for grep.
212 # Message to display before to halting execution.
214 # Finally, you may exempt files based on an ERE matching file names.
215 # For example, to exempt from the sc_space_tab check all files with the
216 # .diff suffix, set this Make variable:
218 # exclude_file_name_regexp--sc_space_tab = \.diff$
220 # Note that while this functionality is mostly inherited via VC_LIST_EXCEPT,
221 # when filtering by name via in_files, we explicitly filter out matching
222 # names here as well.
224 # Initialize each, so that envvar settings cannot interfere.
231 export non_containing
=
233 export with_grep_options
=
235 # By default, _sc_search_regexp does not ignore case.
237 _ignore_case
= $$(test -n
"$$ignore_case" && printf
%s
-i ||
:)
239 define _sc_say_and_exit
240 dummy
=; : so we do not need a semicolon before each use
; \
241 { printf
'%s\n' "$(ME): $$msg" 1>&2; exit
1; };
244 define _sc_search_regexp
245 dummy
=; : so we do not need a semicolon before each use
; \
248 test -n
"$$prohibit" && test -n
"$$require" \
249 && { msg
='Cannot specify both prohibit and require' \
250 $(_sc_say_and_exit
) } ||
:; \
251 test -z
"$$prohibit" && test -z
"$$require" \
252 && { msg
='Should specify either prohibit or require' \
253 $(_sc_say_and_exit
) } ||
:; \
254 test -z
"$$prohibit" && test -n
"$$exclude" \
255 && { msg
='Use of exclude requires a prohibit pattern' \
256 $(_sc_say_and_exit
) } ||
:; \
257 test -n
"$$in_vc_files" && test -n
"$$in_files" \
258 && { msg
='Cannot specify both in_vc_files and in_files' \
259 $(_sc_say_and_exit
) } ||
:; \
260 test "x$$halt" != x \
261 ||
{ msg
='halt not defined' $(_sc_say_and_exit
) }; \
263 : Filter by file name
; \
264 if
test -n
"$$in_files"; then \
265 files
=$$(find
$(srcdir) | grep
-E
"$$in_files" \
266 | grep
-Ev
'$(_sc_excl)'); \
268 files
=$$($(VC_LIST_EXCEPT
)); \
269 if
test -n
"$$in_vc_files"; then \
270 files
=$$(echo
"$$files" | grep
-E
"$$in_vc_files"); \
274 : Filter by content
; \
275 test -n
"$$files" && test -n
"$$containing" \
276 && { files
=$$(grep
-l
"$$containing" $$files); } ||
:; \
277 test -n
"$$files" && test -n
"$$non_containing" \
278 && { files
=$$(grep
-vl
"$$non_containing" $$files); } ||
:; \
280 : Check for the construct
; \
281 if
test -n
"$$files"; then \
282 if
test -n
"$$prohibit"; then \
283 grep
$$with_grep_options $(_ignore_case
) -nE
"$$prohibit" $$files \
284 | grep
-vE
"$${exclude:-^$$}" \
285 && { msg
="$$halt" $(_sc_say_and_exit
) } ||
:; \
287 grep
$$with_grep_options $(_ignore_case
) -LE
"$$require" $$files \
289 && { msg
="$$halt" $(_sc_say_and_exit
) } ||
:; \
295 sc_avoid_if_before_free
:
296 @
$(srcdir)/$(_build-aux
)/useless-if-before-free \
297 $(useless_free_options
) \
298 $$($(VC_LIST_EXCEPT
) | grep
-v useless-if-before-free
) && \
299 { echo
'$(ME): found useless "if" before "free" above' 1>&2; \
302 sc_cast_of_argument_to_free
:
303 @prohibit
='\<free *\( *\(' halt
="don't cast free argument" \
306 sc_cast_of_x_alloc_return_value
:
307 @prohibit
='\*\) *x(m|c|re)alloc\>' \
308 halt
="don't cast x*alloc return value" \
311 sc_cast_of_alloca_return_value
:
312 @prohibit
='\*\) *alloca\>' \
313 halt
="don't cast alloca return value" \
318 halt
='found SPACE-TAB sequence; remove the SPACE' \
321 # Don't use *scanf or the old ato* functions in "real" code.
322 # They provide no error checking mechanism.
323 # Instead, use strto* functions.
324 sc_prohibit_atoi_atof
:
325 @prohibit
='\<([fs]?scanf|ato([filq]|ll)) *\(' \
326 halt
='do not use *scan''f, ato''f, ato''i, ato''l, ato''ll or ato''q' \
329 # Use STREQ rather than comparing strcmp == 0, or != 0.
332 @prohibit
='! *strcmp *\(|\<$(sp_) *[!=]=|[!=]= *$(sp_)' \
333 exclude
=':# *define STRN?EQ\(' \
334 halt
='$(ME): replace strcmp calls above with STREQ/STRNEQ' \
337 # Really. You don't want to use this function.
338 # It may fail to NUL-terminate the destination,
339 # and always NUL-pads out to the specified length.
341 @prohibit
='\<strncpy *\(' \
342 halt
='do not use strncpy, period' \
345 # Pass EXIT_*, not number, to usage, exit, and error (when exiting)
346 # Convert all uses automatically, via these two commands:
347 # git grep -l '\<exit *(1)' \
348 # | grep -vEf .x-sc_prohibit_magic_number_exit \
349 # | xargs --no-run-if-empty \
350 # perl -pi -e 's/(^|[^.])\b(exit ?)\(1\)/$1$2(EXIT_FAILURE)/'
351 # git grep -l '\<exit *(0)' \
352 # | grep -vEf .x-sc_prohibit_magic_number_exit \
353 # | xargs --no-run-if-empty \
354 # perl -pi -e 's/(^|[^.])\b(exit ?)\(0\)/$1$2(EXIT_SUCCESS)/'
355 sc_prohibit_magic_number_exit
:
356 @prohibit
='(^|[^.])\<(usage|exit) ?\([0-9]|\<error ?\([1-9][0-9]*,' \
357 halt
='use EXIT_* values rather than magic number' \
360 # Using EXIT_SUCCESS as the first argument to error is misleading,
361 # since when that parameter is 0, error does not exit. Use '0' instead.
362 sc_error_exit_success
:
363 @prohibit
='error *\(EXIT_SUCCESS,' \
364 in_vc_files
='\.[chly]$$' \
365 halt
='found error (EXIT_SUCCESS' \
368 # "FATAL:" should be fully upper-cased in error messages
369 # "WARNING:" should be fully upper-cased, or fully lower-cased
370 sc_error_message_warn_fatal
:
371 @grep
-nEA2
'[^rp]error *\(' $$($(VC_LIST_EXCEPT
)) \
372 | grep
-E
'"Warning|"Fatal|"fatal' && \
373 { echo
'$(ME): use FATAL, WARNING or warning' 1>&2; \
376 # Error messages should not start with a capital letter
377 sc_error_message_uppercase
:
378 @grep
-nEA2
'[^rp]error *\(' $$($(VC_LIST_EXCEPT
)) \
380 | grep
-vE
'"FATAL|"WARNING|"Java|"C#|PRIuMAX' && \
381 { echo
'$(ME): found capitalized error message' 1>&2; \
384 # Error messages should not end with a period
385 sc_error_message_period
:
386 @grep
-nEA2
'[^rp]error *\(' $$($(VC_LIST_EXCEPT
)) \
387 | grep
-E
'[^."]\."' && \
388 { echo
'$(ME): found error message ending in period' 1>&2; \
392 @prohibit
=file
''system \
394 halt
='found use of "file''system"; spell it "file system"' \
397 # Don't use cpp tests of this symbol. All code assumes config.h is included.
398 sc_prohibit_have_config_h
:
399 @prohibit
='^# *if.*HAVE''_CONFIG_H' \
400 halt
='found use of HAVE''_CONFIG_H; remove' \
403 # Nearly all .c files must include <config.h>. However, we also permit this
404 # via inclusion of a package-specific header, if cfg.mk specified one.
405 # config_h_header must be suitable for grep -E.
406 config_h_header ?
= <config\.h
>
408 @require
='^# *include $(config_h_header)' \
409 in_vc_files
='\.c$$' \
410 halt
='the above files do not include <config.h>' \
413 # You must include <config.h> before including any other header file.
414 # This can possibly be via a package-specific header, if given by cfg.mk.
415 sc_require_config_h_first
:
416 @if
$(VC_LIST_EXCEPT
) | grep
-l
'\.c$$' > /dev
/null
; then \
418 for i in
$$($(VC_LIST_EXCEPT
) | grep
'\.c$$'); do \
419 grep
'^# *include\>' $$i | sed
1q \
420 | grep
-E
'^# *include $(config_h_header)' > /dev
/null \
421 ||
{ echo
$$i; fail
=1; }; \
424 { echo
'$(ME): the above files include some other header' \
425 'before <config.h>' 1>&2; exit
1; } ||
:; \
429 sc_prohibit_HAVE_MBRTOWC
:
430 @prohibit
='\bHAVE_MBRTOWC\b' \
431 halt
="do not use $$prohibit; it is always defined" \
434 # To use this "command" macro, you must first define two shell variables:
435 # h: the header name, with no enclosing <> or ""
436 # re: a regular expression that matches IFF something provided by $h is used.
437 define _sc_header_without_use
438 dummy
=; : so we do not need a semicolon before each use
; \
439 h_esc
=`echo '[<"]'"$$h"'[">]'|sed 's/\./\\\\./g'`; \
440 if
$(VC_LIST_EXCEPT
) | grep
-l
'\.c$$' > /dev
/null
; then \
441 files
=$$(grep
-l
'^# *include '"$$h_esc" \
442 $$($(VC_LIST_EXCEPT
) | grep
'\.c$$')) && \
443 grep
-LE
"$$re" $$files | grep .
&& \
444 { echo
"$(ME): the above files include $$h but don't use it" \
445 1>&2; exit
1; } ||
:; \
450 # Prohibit the inclusion of assert.h without an actual use of assert.
451 sc_prohibit_assert_without_use
:
452 @h
='assert.h' re
='\<assert *\(' $(_sc_header_without_use
)
454 # Prohibit the inclusion of close-stream.h without an actual use.
455 sc_prohibit_close_stream_without_use
:
456 @h
='close-stream.h' re
='\<close_stream *\(' $(_sc_header_without_use
)
458 # Prohibit the inclusion of getopt.h without an actual use.
459 sc_prohibit_getopt_without_use
:
460 @h
='getopt.h' re
='\<getopt(_long)? *\(' $(_sc_header_without_use
)
462 # Don't include quotearg.h unless you use one of its functions.
463 sc_prohibit_quotearg_without_use
:
464 @h
='quotearg.h' re
='\<quotearg(_[^ ]+)? *\(' $(_sc_header_without_use
)
466 # Don't include quote.h unless you use one of its functions.
467 sc_prohibit_quote_without_use
:
468 @h
='quote.h' re
='\<quote((_n)? *\(|_quoting_options\>)' \
469 $(_sc_header_without_use
)
471 # Don't include this header unless you use one of its functions.
472 sc_prohibit_long_options_without_use
:
473 @h
='long-options.h' re
='\<parse_long_options *\(' \
474 $(_sc_header_without_use
)
476 # Don't include this header unless you use one of its functions.
477 sc_prohibit_inttostr_without_use
:
478 @h
='inttostr.h' re
='\<(off|[iu]max|uint)tostr *\(' \
479 $(_sc_header_without_use
)
481 # Don't include this header unless you use one of its functions.
482 sc_prohibit_ignore_value_without_use
:
483 @h
='ignore-value.h' re
='\<ignore_(value|ptr) *\(' \
484 $(_sc_header_without_use
)
486 # Don't include this header unless you use one of its functions.
487 sc_prohibit_error_without_use
:
489 re
='\<error(_at_line|_print_progname|_one_per_line|_message_count)? *\('\
490 $(_sc_header_without_use
)
492 # Don't include xalloc.h unless you use one of its functions.
493 # Consider these symbols:
494 # perl -lne '/^# *define (\w+)\(/ and print $1' lib/xalloc.h|grep -v '^__';
495 # perl -lne '/^(?:extern )?(?:void|char) \*?(\w+) *\(/ and print $1' lib/xalloc.h
496 # Divide into two sets on case, and filter each through this:
497 # | sort | perl -MRegexp::Assemble -le \
498 # 'print Regexp::Assemble->new(file => "/dev/stdin")->as_string'|sed 's/\?://g'
499 # Note this was produced by the above:
501 #x(((2n?)?re|c(har)?|n(re|m)|z)alloc|alloc_(oversized|die)|m(alloc|emdup)|strdup)
502 # But we can do better, in at least two ways:
503 # 1) take advantage of two "dup"-suffixed strings:
504 # x(((2n?)?re|c(har)?|n(re|m)|[mz])alloc|alloc_(oversized|die)|(mem|str)dup)
505 # 2) notice that "c(har)?|[mz]" is equivalent to the shorter and more readable
507 # x(((2n?)?re|char|n(re|m)|[cmz])alloc|alloc_(oversized|die)|(mem|str)dup)
508 _xa1
= x
(((2n?
)?re|char|n
(re|m
)|
[cmz
])alloc|alloc_
(oversized|die
)|
(mem|str
)dup
)
509 _xa2
= X
([CZ
]|N?M
)ALLOC
510 sc_prohibit_xalloc_without_use
:
512 re
='\<($(_xa1)|$(_xa2)) *\('\
513 $(_sc_header_without_use
)
515 # Extract function names:
516 # perl -lne '/^(?:extern )?(?:void|char) \*?(\w+) *\(/ and print $1' lib/hash.h
518 clear|delete|free|get_
(first|next
)|insert|lookup|print_statistics|reset_tuning
519 _hash_fn
= \
<($(_hash_re
)) *\
(
520 _hash_struct
= (struct
)?\
<[Hh
]ash_
(table|tuning
)\
>
521 sc_prohibit_hash_without_use
:
523 re
='$(_hash_fn)|$(_hash_struct)'\
524 $(_sc_header_without_use
)
526 sc_prohibit_cloexec_without_use
:
527 @h
='cloexec.h' re
='\<(set_cloexec_flag|dup_cloexec) *\(' \
528 $(_sc_header_without_use
)
530 sc_prohibit_posixver_without_use
:
531 @h
='posixver.h' re
='\<posix2_version *\(' $(_sc_header_without_use
)
533 sc_prohibit_same_without_use
:
534 @h
='same.h' re
='\<same_name *\(' $(_sc_header_without_use
)
536 sc_prohibit_hash_pjw_without_use
:
539 $(_sc_header_without_use
)
541 sc_prohibit_safe_read_without_use
:
542 @h
='safe-read.h' re
='(\<SAFE_READ_ERROR\>|\<safe_read *\()' \
543 $(_sc_header_without_use
)
545 sc_prohibit_argmatch_without_use
:
547 re
='(\<(ARRAY_CARDINALITY|X?ARGMATCH(|_TO_ARGUMENT|_VERIFY))\>|\<(invalid_arg|argmatch(_exit_fn|_(in)?valid)?) *\()' \
548 $(_sc_header_without_use
)
550 sc_prohibit_canonicalize_without_use
:
551 @h
='canonicalize.h' \
552 re
='CAN_(EXISTING|ALL_BUT_LAST|MISSING)|canonicalize_(mode_t|filename_mode|file_name)' \
553 $(_sc_header_without_use
)
555 sc_prohibit_root_dev_ino_without_use
:
556 @h
='root-dev-ino.h' \
557 re
='(\<ROOT_DEV_INO_(CHECK|WARN)\>|\<get_root_dev_ino *\()' \
558 $(_sc_header_without_use
)
560 sc_prohibit_openat_without_use
:
562 re
='\<(openat_(permissive|needs_fchdir|(save|restore)_fail)|l?(stat|ch(own|mod))at|(euid)?accessat)\>' \
563 $(_sc_header_without_use
)
565 # Prohibit the inclusion of c-ctype.h without an actual use.
566 ctype_re
= isalnum|isalpha|isascii|isblank|iscntrl|isdigit|isgraph|islower\
567 |isprint|ispunct|isspace|isupper|isxdigit|tolower|toupper
568 sc_prohibit_c_ctype_without_use
:
569 @h
='c-ctype.h' re
='\<c_($(ctype_re)) *\(' \
570 $(_sc_header_without_use
)
573 _sp
= $(_empty
) $(_empty
)
574 # The following list was generated by running:
575 # man signal.h|col -b|perl -ne '/bsd_signal.*;/.../sigwaitinfo.*;/ and print' \
576 # | perl -lne '/^\s+(?:int|void).*?(\w+).*/ and print $1' | fmt
578 bsd_signal kill killpg pthread_kill pthread_sigmask raise sigaction \
579 sigaddset sigaltstack sigdelset sigemptyset sigfillset sighold sigignore \
580 siginterrupt sigismember signal sigpause sigpending sigprocmask sigqueue \
581 sigrelse sigset sigsuspend sigtimedwait sigwait sigwaitinfo
582 _sig_function_re
= $(subst $(_sp
),|
,$(strip $(_sig_functions
)))
583 # The following were extracted from "man signal.h" manually.
584 _sig_types_and_consts
= \
585 MINSIGSTKSZ SA_NOCLDSTOP SA_NOCLDWAIT SA_NODEFER SA_ONSTACK \
586 SA_RESETHAND SA_RESTART SA_SIGINFO SIGEV_NONE SIGEV_SIGNAL \
587 SIGEV_THREAD SIGSTKSZ SIG_BLOCK SIG_SETMASK SIG_UNBLOCK SS_DISABLE \
588 SS_ONSTACK mcontext_t pid_t sig_atomic_t sigevent siginfo_t sigset_t \
589 sigstack sigval stack_t ucontext_t
590 # generated via this:
591 # perl -lne '/^#ifdef (SIG\w+)/ and print $1' lib/sig2str.c|sort -u|fmt -70
593 SIGABRT SIGALRM SIGALRM1 SIGBUS SIGCANCEL SIGCHLD SIGCLD SIGCONT \
594 SIGDANGER SIGDIL SIGEMT SIGFPE SIGFREEZE SIGGRANT SIGHUP SIGILL \
595 SIGINFO SIGINT SIGIO SIGIOT SIGKAP SIGKILL SIGKILLTHR SIGLOST SIGLWP \
596 SIGMIGRATE SIGMSG SIGPHONE SIGPIPE SIGPOLL SIGPRE SIGPROF SIGPWR \
597 SIGQUIT SIGRETRACT SIGSAK SIGSEGV SIGSOUND SIGSTKFLT SIGSTOP SIGSYS \
598 SIGTERM SIGTHAW SIGTRAP SIGTSTP SIGTTIN SIGTTOU SIGURG SIGUSR1 \
599 SIGUSR2 SIGVIRT SIGVTALRM SIGWAITING SIGWINCH SIGWIND SIGWINDOW \
601 _sig_syms_re
= $(subst $(_sp
),|
,$(strip $(_sig_names
) $(_sig_types_and_consts
)))
603 # Prohibit the inclusion of signal.h without an actual use.
604 sc_prohibit_signal_without_use
:
606 re
='\<($(_sig_function_re)) *\(|\<($(_sig_syms_re))\>' \
607 $(_sc_header_without_use
)
609 # Don't include stdio--.h unless you use one of its functions.
610 sc_prohibit_stdio--_without_use
:
611 @h
='stdio--.h' re
='\<((f(re)?|p)open|tmpfile) *\(' \
612 $(_sc_header_without_use
)
614 # Don't include stdio-safer.h unless you use one of its functions.
615 sc_prohibit_stdio-safer_without_use
:
616 @h
='stdio-safer.h' re
='\<((f(re)?|p)open|tmpfile)_safer *\(' \
617 $(_sc_header_without_use
)
619 # Prohibit the inclusion of strings.h without a sensible use.
620 # Using the likes of bcmp, bcopy, bzero, index or rindex is not sensible.
621 sc_prohibit_strings_without_use
:
623 re
='\<(strn?casecmp|ffs(ll)?)\>' \
624 $(_sc_header_without_use
)
626 # Get the list of symbol names with this:
627 # perl -lne '/^# *define ([A-Z]\w+)\(/ and print $1' lib/intprops.h|fmt
629 TYPE_IS_INTEGER TYPE_TWOS_COMPLEMENT TYPE_ONES_COMPLEMENT \
630 TYPE_SIGNED_MAGNITUDE TYPE_SIGNED TYPE_MINIMUM TYPE_MAXIMUM \
631 INT_BITS_STRLEN_BOUND INT_STRLEN_BOUND INT_BUFSIZE_BOUND \
632 INT_ADD_RANGE_OVERFLOW INT_SUBTRACT_RANGE_OVERFLOW \
633 INT_NEGATE_RANGE_OVERFLOW INT_MULTIPLY_RANGE_OVERFLOW \
634 INT_DIVIDE_RANGE_OVERFLOW INT_REMAINDER_RANGE_OVERFLOW \
635 INT_LEFT_SHIFT_RANGE_OVERFLOW INT_ADD_OVERFLOW INT_SUBTRACT_OVERFLOW \
636 INT_NEGATE_OVERFLOW INT_MULTIPLY_OVERFLOW INT_DIVIDE_OVERFLOW \
637 INT_REMAINDER_OVERFLOW INT_LEFT_SHIFT_OVERFLOW
638 _intprops_syms_re
= $(subst $(_sp
),|
,$(strip $(_intprops_names
)))
639 # Prohibit the inclusion of intprops.h without an actual use.
640 sc_prohibit_intprops_without_use
:
642 re
='\<($(_intprops_syms_re)) *\(' \
643 $(_sc_header_without_use
)
645 _stddef_syms_re
= NULL|offsetof|ptrdiff_t|size_t|wchar_t
646 # Prohibit the inclusion of stddef.h without an actual use.
647 sc_prohibit_stddef_without_use
:
649 re
='\<($(_stddef_syms_re))\>' \
650 $(_sc_header_without_use
)
652 _de1
= dirfd|
(close|
(fd
)?open|read|rewind|seek|tell
)dir(64)?
(_r
)?
653 _de2
= (versionsort|struct dirent|getdirentries|alphasort|scandir
(at
)?
)(64)?
654 _de3
= MAXNAMLEN|DIR|ino_t|d_ino|d_fileno|d_namlen
655 _dirent_syms_re
= $(_de1
)|
$(_de2
)|
$(_de3
)
656 # Prohibit the inclusion of dirent.h without an actual use.
657 sc_prohibit_dirent_without_use
:
659 re
='\<($(_dirent_syms_re))\>' \
660 $(_sc_header_without_use
)
662 # Prohibit the inclusion of verify.h without an actual use.
663 sc_prohibit_verify_without_use
:
665 re
='\<(verify(true|expr)?|static_assert) *\(' \
666 $(_sc_header_without_use
)
668 # Don't include xfreopen.h unless you use one of its functions.
669 sc_prohibit_xfreopen_without_use
:
670 @h
='xfreopen.h' re
='\<xfreopen *\(' $(_sc_header_without_use
)
673 @prohibit
='\<(HAVE''_FCNTL_H|O''_NDELAY)\>' \
674 halt
='do not use HAVE''_FCNTL_H or O'_NDELAY \
677 # FIXME: warn about definitions of EXIT_FAILURE, EXIT_SUCCESS, STREQ
679 # Each nonempty ChangeLog line must start with a year number, or a TAB.
681 @prohibit
='^[^12 ]' \
682 in_vc_files
='^ChangeLog$$' \
683 halt
='found unexpected prefix in a ChangeLog' \
686 # Ensure that each .c file containing a "main" function also
687 # calls set_program_name.
689 @require
='set_program_name *\(m?argv\[0\]\);' \
690 in_vc_files
='\.c$$' \
691 containing
='\<main *(' \
692 halt
='the above files do not call set_program_name' \
695 # Ensure that each .c file containing a "main" function also
696 # calls bindtextdomain.
698 @require
='bindtextdomain *\(' \
699 in_vc_files
='\.c$$' \
700 containing
='\<main *(' \
701 halt
='the above files do not call bindtextdomain' \
704 # Require that the final line of each test-lib.sh-using test be this one:
706 # Note: this test requires GNU grep's --label= option.
707 Exit_witness_file ?
= tests
/test-lib.sh
708 Exit_base
:= $(notdir $(Exit_witness_file
))
709 sc_require_test_exit_idiom
:
710 @if
test -f
$(srcdir)/$(Exit_witness_file
); then \
712 for i in
$$(grep
-l
-F
'srcdir/$(Exit_base)' \
713 $$($(VC_LIST
) tests
)); do \
714 tail
-n1
$$i | grep
'^Exit .' > /dev
/null \
715 && : ||
{ die
=1; echo
$$i; } \
718 { echo
1>&2 '$(ME): the final line in each of the above is not:'; \
719 echo
1>&2 'Exit something'; \
725 halt
='found trailing blank(s)' \
728 # Match lines like the following, but where there is only one space
729 # between the options and the description:
730 # -D, --all-repeated[=delimit-method] print all duplicate lines\n
731 longopt_re
= --[a-z
][0-9A-Za-z-
]*(\
[?
=[0-9A-Za-z-
]*\
]?
)?
732 sc_two_space_separator_in_usage
:
733 @prohibit
='^ *(-[A-Za-z],)? $(longopt_re) [^ ].*\\$$' \
734 halt
='help2man requires at least two spaces between an option and its description'\
737 # A regexp matching function names like "error" that may be used
738 # to emit translatable messages.
739 _gl_translatable_diag_func_re ?
= error
741 # Look for diagnostics that aren't marked for translation.
742 # This won't find any for which error's format string is on a separate line.
743 sc_unmarked_diagnostics
:
744 @prohibit
='\<$(_gl_translatable_diag_func_re) *\([^"]*"[^"]*[a-z]{3}' \
745 exclude
='(_|ngettext ?)\(' \
746 halt
='$(ME): found unmarked diagnostic(s)' \
749 # Avoid useless parentheses like those in this example:
750 # #if defined (SYMBOL) || defined (SYM2)
751 sc_useless_cpp_parens
:
752 @prohibit
='^# *if .*defined *\(' \
753 halt
='found useless parentheses in cpp directive' \
756 # List headers for which HAVE_HEADER_H is always true, assuming you are
757 # using the appropriate gnulib module. CAUTION: for each "unnecessary"
758 # #if HAVE_HEADER_H that you remove, be sure that your project explicitly
759 # requires the gnulib module that guarantees the usability of that header.
760 gl_assured_headers_
= \
761 cd
$(gnulib_dir
)/lib
&& echo
*.in.h|sed
's/\.in\.h//g'
763 # Convert the list of names to upper case, and replace each space with "|".
764 az_
= abcdefghijklmnopqrstuvwxyz
765 AZ_
= ABCDEFGHIJKLMNOPQRSTUVWXYZ
766 gl_header_upper_case_or_
= \
767 $$($(gl_assured_headers_
) \
768 | tr
$(az_
)/.
- $(AZ_
)___ \
771 sc_prohibit_always_true_header_tests
:
772 @or
=$(gl_header_upper_case_or_
); \
773 re
="HAVE_($$or)_H"; \
774 prohibit
='\<'"$$re"'\>' \
775 halt
=$$(printf
'%s\n' \
776 'do not test the above HAVE_<header>_H symbol(s);' \
777 ' with the corresponding gnulib module, they are always true') \
780 sc_prohibit_defined_have_decl_tests
:
781 @prohibit
='#[ ]*if(n?def|.*\<defined)\>[ (]+HAVE_DECL_' \
782 halt
='$(ME): HAVE_DECL macros are always defined' \
785 # ==================================================================
786 gl_other_headers_ ?
= \
791 # Perl -lne code to extract "significant" cpp-defined symbols from a
792 # gnulib header file, eliminating a few common false-positives.
793 # The exempted names below are defined only conditionally in gnulib,
794 # and hence sometimes must/may be defined in application code.
795 gl_extract_significant_defines_
= \
796 /^\
# *define ([^_ (][^ (]*)(\s*\(|\s+\w+)/\
797 && $$2 !~
/(?
:rpl_|_used_without_
)/\
798 && $$1 !~
/^
(?
:NSIG|ENODATA
)$$/\
799 && $$1 !~
/^
(?
:SA_RESETHAND|SA_RESTART
)$$/\
802 # Create a list of regular expressions matching the names
803 # of macros that are guaranteed to be defined by parts of gnulib.
805 gen_h
=$(gl_generated_headers_
); \
806 (cd
$(gnulib_dir
)/lib
; \
807 for f in
*.in.h
$(gl_other_headers_
); do \
809 && perl
-lne
'$(gl_extract_significant_defines_)' $$f; \
812 | sed
's/^/^ *# *(define|undef) */;s/$$/\\>/'
815 # Don't define macros that we already get from gnulib header files.
816 sc_prohibit_always-defined_macros
:
817 @if
test -d
$(gnulib_dir
); then \
818 case
$$(echo
all: | grep
-l
-f
- Makefile
) in Makefile
);; *) \
819 echo
'$(ME): skipping $@: you lack GNU grep' 1>&2; exit
0;; \
821 $(def_sym_regex
) | grep
-E
-f
- $$($(VC_LIST_EXCEPT
)) \
822 && { echo
'$(ME): define the above via some gnulib .h file' \
823 1>&2; exit
1; } ||
:; \
825 # ==================================================================
827 # Prohibit checked in backup files.
828 sc_prohibit_backup_files
:
829 @
$(VC_LIST
) | grep
'~$$' && \
830 { echo
'$(ME): found version controlled backup file' 1>&2; \
833 # Require the latest GPL.
835 @prohibit
='either ''version [^3]' \
836 halt
='GPL vN, N!=3' \
839 # Require the latest GFDL. Two regexp, since some .texi files end up
840 # line wrapping between 'Free Documentation License,' and 'Version'.
841 _GFDL_regexp
= (Free
''Documentation.
*Version
1\.
[^
3]|Version
1\.
[^
3] or any
)
843 @prohibit
='$(_GFDL_regexp)' \
844 halt
='GFDL vN, N!=3' \
847 # Don't use Texinfo's @acronym{}.
848 # http://lists.gnu.org/archive/html/bug-gnulib/2010-03/msg00321.html
849 texinfo_suffix_re_ ?
= \.
(txi|texi
(nfo
)?
)$$
851 @prohibit
='@acronym\{' \
852 in_vc_files
='$(texinfo_suffix_re_)' \
853 halt
='found use of Texinfo @acronym{}' \
857 Author|Date|Header|Id|Name|Locker|Log|RCSfile|Revision|Source|State
859 sc_prohibit_cvs_keyword
:
860 @prohibit
='\$$($(cvs_keywords))\$$' \
861 halt
='do not use CVS keyword expansion' \
864 # This Perl code is slightly obfuscated. Not only is each "$" doubled
865 # because it's in a Makefile, but the $$c's are comments; we cannot
866 # use "#" due to the way the script ends up concatenated onto one line.
867 # It would be much more concise, and would produce better output (including
868 # counts) if written as:
869 # perl -ln -0777 -e '/\n(\n+)$/ and print "$ARGV: ".length $1' ...
870 # but that would be far less efficient, reading the entire contents
871 # of each file, rather than just the last two bytes of each.
872 # In addition, while the code below detects both blank lines and a missing
873 # newline at EOF, the above detects only the former.
875 # This is a perl script that is expected to be the single-quoted argument
876 # to a command-line "-le". The remaining arguments are file names.
877 # Print the name of each file that does not end in exactly one newline byte.
878 # I.e., warn if there are blank lines (2 or more newlines), or if the
879 # last byte is not a newline. However, currently we don't complain
880 # about any file that contains exactly one byte.
881 # Exit nonzero if at least one such file is found, otherwise, exit 0.
882 # Warn about, but otherwise ignore open failure. Ignore seek/read failure.
884 # Use this if you want to remove trailing empty lines from selected files:
885 # perl -pi -0777 -e 's/\n\n+$/\n/' files...
887 require_exactly_one_NL_at_EOF_
= \
888 foreach my
$$f (@ARGV
) \
890 open F
, "<", $$f or
(warn
"failed to open $$f: $$!\n"), next
; \
891 my
$$p = sysseek
(F
, -2, 2); \
892 my
$$c = "seek failure probably means file has < 2 bytes; ignore"; \
893 my
$$last_two_bytes; \
894 defined
$$p and
$$p = sysread F
, $$last_two_bytes, 2; \
896 $$c = "ignore read failure"; \
897 $$p && ($$last_two_bytes eq
"\n\n" \
898 || substr
($$last_two_bytes,1) ne
"\n") \
899 and
(print $$f), $$fail=1; \
901 END
{ exit defined
$$fail }
902 sc_prohibit_empty_lines_at_EOF
:
903 @perl
-le
'$(require_exactly_one_NL_at_EOF_)' $$($(VC_LIST_EXCEPT
)) \
904 ||
{ echo
'$(ME): empty line(s) or no newline at EOF' \
907 # Make sure we don't use st_blocks. Use ST_NBLOCKS instead.
908 # This is a bit of a kludge, since it prevents use of the string
909 # even in comments, but for now it does the job with no false positives.
910 sc_prohibit_stat_st_blocks
:
911 @prohibit
='[.>]st_blocks' \
912 halt
='do not use st_blocks; use ST_NBLOCKS' \
915 # Make sure we don't define any S_IS* macros in src/*.c files.
916 # They're already defined via gnulib's sys/stat.h replacement.
917 sc_prohibit_S_IS_definition
:
918 @prohibit
='^ *# *define *S_IS' \
919 halt
='do not define S_IS* macros; include <sys/stat.h>' \
922 # Perl block to convert a match to FILE_NAME:LINENO:TEST,
923 # that is shared by two definitions below.
924 perl_filename_lineno_text_
= \
926 -e
' $$n = ($$` =~ tr/\n/\n/ + 1);' \
927 -e
' ($$v = $$&) =~ s/\n/\\n/g;' \
928 -e
' print "$$ARGV:$$n:$$v\n";' \
931 prohibit_doubled_word_RE_ ?
= \
932 /\b(then?|
[iao
]n|i
[fst
]|but|f?or|at|and|
[dt
]o
)\s
+\
1\b/gims
933 prohibit_doubled_word_
= \
934 -e
'while ($(prohibit_doubled_word_RE_))' \
935 $(perl_filename_lineno_text_
)
937 # Define this to a regular expression that matches
938 # any filename:dd:match lines you want to ignore.
939 # The default is to ignore no matches.
940 ignore_doubled_word_match_RE_ ?
= ^
$$
942 sc_prohibit_doubled_word
:
943 @perl
-n
-0777 $(prohibit_doubled_word_
) $$($(VC_LIST_EXCEPT
)) \
944 | grep
-vE
'$(ignore_doubled_word_match_RE_)' \
945 | grep .
&& { echo
'$(ME): doubled words' 1>&2; exit
1; } ||
:
947 # A regular expression matching undesirable combinations of words like
948 # "can not"; this matches them even when the two words appear on different
949 # lines, but not when there is an intervening delimiter like "#" or "*".
950 # Similarly undesirable, "See @xref{...}", since an @xref should start
951 # a sentence. Explicitly prohibit any prefix of "see" or "also".
952 # Also prohibit a prefix matching "\w+ +".
953 # @pxref gets the same see/also treatment and should be parenthesized;
954 # presume it must *not* start a sentence.
955 bad_xref_re_ ?
= (?
:[\w
,:;] +|
(?
:see|also
)\s
+)\@xref\
{
956 bad_pxref_re_ ?
= (?
:[.
!?
]|
(?
:see|also
))\s
+\@pxref\
{
957 prohibit_undesirable_word_seq_RE_ ?
= \
958 /(?
:\bcan\s
+not
\b|
$(bad_xref_re_
)|
$(bad_pxref_re_
))/gims
959 prohibit_undesirable_word_seq_
= \
960 -e
'while ($(prohibit_undesirable_word_seq_RE_))' \
961 $(perl_filename_lineno_text_
)
962 # Define this to a regular expression that matches
963 # any filename:dd:match lines you want to ignore.
964 # The default is to ignore no matches.
965 ignore_undesirable_word_sequence_RE_ ?
= ^
$$
967 sc_prohibit_undesirable_word_seq
:
968 @perl
-n
-0777 $(prohibit_undesirable_word_seq_
) \
969 $$($(VC_LIST_EXCEPT
)) \
970 | grep
-vE
'$(ignore_undesirable_word_sequence_RE_)' | grep . \
971 && { echo
'$(ME): undesirable word sequence' >&2; exit
1; } ||
:
973 _ptm1
= use
"test C1 && test C2", not
"test C1 -''a C2"
974 _ptm2
= use
"test C1 || test C2", not
"test C1 -''o C2"
975 # Using test's -a and -o operators is not portable.
976 # We prefer test over [, since the latter is spelled [[ in configure.ac.
977 sc_prohibit_test_minus_ao
:
978 @prohibit
='(\<test| \[+) .+ -[ao] ' \
979 halt
='$(_ptm1); $(_ptm2)' \
982 # Avoid a test bashism.
983 sc_prohibit_test_double_equal
:
984 @prohibit
='(\<test| \[+) .+ == ' \
985 containing
='#! */bin/[a-z]*sh' \
986 halt
='use "test x = x", not "test x =''= x"' \
989 # Each program that uses proper_name_utf8 must link with one of the
990 # ICONV libraries. Otherwise, some ICONV library must appear in LDADD.
991 # The perl -0777 invocation below extracts the possibly-multi-line
992 # definition of LDADD from the appropriate Makefile.am and exits 0
993 # when it contains "ICONV".
994 sc_proper_name_utf8_requires_ICONV
:
995 @progs
=$$(grep
-l
'proper_name_utf8 ''("' $$($(VC_LIST_EXCEPT
)));\
996 if
test "x$$progs" != x
; then \
998 for p in
$$progs; do \
999 dir=$$(dirname
"$$p"); \
1001 -ne
'exit !(/^LDADD =(.+?[^\\]\n)/ms && $$1 =~ /ICONV/)' \
1002 $$dir/Makefile.am
&& continue
; \
1003 base
=$$(basename "$$p" .c
); \
1004 grep
"$${base}_LDADD.*ICONV)" $$dir/Makefile.am
> /dev
/null \
1005 ||
{ fail
=1; echo
1>&2 "$(ME): $$p uses proper_name_utf8"; }; \
1007 test $$fail = 1 && \
1008 { echo
1>&2 '$(ME): the above do not link with any ICONV library'; \
1012 # Warn about "c0nst struct Foo const foo[]",
1013 # but not about "char const *const foo" or "#define const const".
1015 @prohibit
='\bconst\b[[:space:][:alnum:]]{2,}\bconst\b' \
1016 halt
='redundant "const" in declarations' \
1017 $(_sc_search_regexp
)
1019 sc_const_long_option
:
1020 @prohibit
='^ *static.*struct option ' \
1021 exclude
='const struct option|struct option const' \
1022 halt
='$(ME): add "const" to the above declarations' \
1023 $(_sc_search_regexp
)
1026 $$(sed
-n
'/^\*.* $(PREV_VERSION_REGEXP) ([0-9-]*)/,$$p' \
1029 's/^Copyright.+?Free\sSoftware\sFoundation,\sInc\.\n//ms' \
1033 # Ensure that we don't accidentally insert an entry into an old NEWS block.
1035 @if
test -f
$(srcdir)/NEWS
; then \
1036 test "$(NEWS_hash)" = '$(old_NEWS_hash)' && : || \
1037 { echo
'$(ME): you have modified old NEWS' 1>&2; exit
1; }; \
1040 # Update the hash stored above. Do this after each release and
1041 # for any corrections to old entries.
1042 update-NEWS-hash
: NEWS
1043 perl
-pi
-e
's/^(old_NEWS_hash[ \t]+:?=[ \t]+).*/$${1}'"$(NEWS_hash)/" \
1046 # Ensure that we use only the standard $(VAR) notation,
1047 # not @...@ in Makefile.am, now that we can rely on automake
1048 # to emit a definition for each substituted variable.
1049 # However, there is still one case in which @VAR@ use is not just
1050 # legitimate, but actually required: when augmenting an automake-defined
1051 # variable with a prefix. For example, gettext uses this:
1052 # MAKEINFO = env LANG= LC_MESSAGES= LC_ALL= LANGUAGE= @MAKEINFO@
1053 # otherwise, makeinfo would put German or French (current locale)
1054 # navigation hints in the otherwise-English documentation.
1056 # Allow the package to add exceptions via a hook in cfg.mk;
1057 # for example, @PRAGMA_SYSTEM_HEADER@ can be permitted by
1058 # setting this to ' && !/PRAGMA_SYSTEM_HEADER/'.
1059 _makefile_at_at_check_exceptions ?
=
1060 sc_makefile_at_at_check
:
1061 @perl
-ne
'/\@\w+\@/' \
1062 -e
' && !/(\w+)\s+=.*\@\1\@$$/' \
1063 -e
''$(_makefile_at_at_check_exceptions
) \
1064 -e
'and (print "$$ARGV:$$.: $$_"), $$m=1; END {exit !$$m}' \
1065 $$($(VC_LIST_EXCEPT
) | grep
-E
'(^|/)(Makefile\.am|[^/]+\.mk)$$') \
1066 && { echo
'$(ME): use $$(...), not @...@' 1>&2; exit
1; } ||
:
1069 if sed
-n
$(news-check-lines-spec
)p
$< \
1070 | grep
-E
$(news-check-regexp
) >/dev
/null
; then \
1073 echo
'NEWS: $$(news-check-regexp) failed to match' 1>&2; \
1077 sc_makefile_TAB_only_indentation
:
1078 @prohibit
='^ [ ]{8}' \
1079 in_vc_files
='akefile|\.mk$$' \
1080 halt
='found TAB-8-space indentation' \
1081 $(_sc_search_regexp
)
1084 @prohibit
='(AC_DEFINE(_UNQUOTED)?|AC_DEFUN)\([^[]' \
1085 in_vc_files
='(^configure\.ac|\.m4)$$' \
1086 halt
='quote the first arg to AC_DEF*' \
1087 $(_sc_search_regexp
)
1089 fix_po_file_diag
= \
1090 'you have changed the set of files with translatable diagnostics;\n\
1091 apply the above patch\n'
1093 # Verify that all source files using _() are listed in po/POTFILES.in.
1094 po_file ?
= $(srcdir)/po
/POTFILES.in
1095 generated_files ?
= $(srcdir)/lib
/*.
[ch
]
1097 @if
test -f
$(po_file
); then \
1098 grep
-E
-v
'^(#|$$)' $(po_file
) \
1099 | grep
-v
'^src/false\.c$$' |
sort > $@
-1; \
1101 for file in
$$($(VC_LIST_EXCEPT
)) $(generated_files
); do \
1102 test -r
$$file || continue
; \
1104 *.m4|
*.mk
) continue
;; \
1110 base
=`expr " $$file" : ' \(.*\)\..'`; \
1111 { test -f
$$base.l ||
test -f
$$base.y
; } && continue
;; \
1113 files
="$$files $$file"; \
1115 grep
-E
-l
'\b(N?_|gettext *)\([^)"]*("|$$)' $$files \
1116 | sed
's|^$(_dot_escaped_srcdir)/||' |
sort -u
> $@
-2; \
1117 diff
-u
-L
$(po_file
) -L
$(po_file
) $@
-1 $@
-2 \
1118 ||
{ printf
'$(ME): '$(fix_po_file_diag
) 1>&2; exit
1; }; \
1122 # Sometimes it is useful to change the PATH environment variable
1123 # in Makefiles. When doing so, it's better not to use the Unix-centric
1124 # path separator of ':', but rather the automake-provided '$(PATH_SEPARATOR)'.
1125 msg
= '$(ME): Do not use ":" above; use $$(PATH_SEPARATOR) instead'
1126 sc_makefile_path_separator_check
:
1127 @prohibit
='PATH[=].*:' \
1128 in_vc_files
='akefile|\.mk$$' \
1130 $(_sc_search_regexp
)
1132 # Check that 'make alpha' will not fail at the end of the process,
1133 # i.e., when pkg-M.N.tar.xz already exists (either in "." or in ../release)
1136 if
test -d
$(release_archive_dir
); then \
1137 for file in
$(DIST_ARCHIVES
); do \
1138 for p in .
/ $(release_archive_dir
)/; do \
1139 test -e
$$p$$file || continue
; \
1141 ||
{ echo ERROR
: $$p$$file is not writable
; fail
=1; }; \
1144 test "$$fail" && exit
1 ||
: ; \
1148 v_etc_file
= $(gnulib_dir
)/lib
/version-etc.c
1149 sample-test
= tests
/sample-test
1150 texi
= doc
/$(PACKAGE
).texi
1151 # Make sure that the copyright date in $(v_etc_file) is up to date.
1152 # Do the same for the $(sample-test) and the main doc/.texi file.
1154 @require
='enum { COPYRIGHT_YEAR = '$$(date
+%Y
)' };' \
1155 in_files
=$(v_etc_file
) \
1156 halt
='out of date copyright in $(v_etc_file); update it' \
1157 $(_sc_search_regexp
)
1158 @require
='# Copyright \(C\) '$$(date
+%Y
)' Free' \
1159 in_vc_files
=$(sample-test
) \
1160 halt
='out of date copyright in $(sample-test); update it' \
1161 $(_sc_search_regexp
)
1162 @require
='Copyright @copyright\{\} .*'$$(date
+%Y
)' Free' \
1163 in_vc_files
=$(texi
) \
1164 halt
='out of date copyright in $(texi); update it' \
1165 $(_sc_search_regexp
)
1167 # If tests/help-version exists and seems to be new enough, assume that its
1168 # use of init.sh and path_prepend_ is correct, and ensure that every other
1169 # use of init.sh is identical.
1170 # This is useful because help-version cross-checks prog --version
1171 # with $(VERSION), which verifies that its path_prepend_ invocation
1172 # sets PATH correctly. This is an inexpensive way to ensure that
1173 # the other init.sh-using tests also get it right.
1174 _hv_file ?
= $(srcdir)/tests
/help-version
1175 _hv_regex_weak ?
= ^
*\. .
*/init\.sh
"
1176 # Fix syntax-highlighters "
1177 _hv_regex_strong ?
= ^
*\.
"\$${srcdir=\.}/init\.sh"
1178 sc_cross_check_PATH_usage_in_tests
:
1179 @if
test -f
$(_hv_file
); then \
1180 grep
-l
'VERSION mismatch' $(_hv_file
) >/dev
/null \
1181 ||
{ echo
"$@: skipped: no such file: $(_hv_file)" 1>&2; \
1183 grep
-lE
'$(_hv_regex_strong)' $(_hv_file
) >/dev
/null \
1184 ||
{ echo
"$@: $(_hv_file) lacks conforming use of init.sh" 1>&2; \
1186 good
=$$(grep
-E
'$(_hv_regex_strong)' $(_hv_file
)); \
1187 grep
-LFx
"$$good" \
1188 $$(grep
-lE
'$(_hv_regex_weak)' $$($(VC_LIST_EXCEPT
))) \
1190 { echo
"$(ME): the above files use path_prepend_ inconsistently" \
1191 1>&2; exit
1; } ||
:; \
1194 # BRE regex of file contents to identify a test script.
1195 _test_script_regex ?
= \
<init\.sh\
>
1197 # In tests, use "compare expected actual", not the reverse.
1198 sc_prohibit_reversed_compare_failure
:
1199 @prohibit
='\<compare [^ ]+ ([^ ]*exp|/dev/null)' \
1200 containing
='$(_test_script_regex)' \
1201 halt
='reversed compare arguments' \
1202 $(_sc_search_regexp
)
1204 # #if HAVE_... will evaluate to false for any non numeric string.
1205 # That would be flagged by using -Wundef, however gnulib currently
1206 # tests many undefined macros, and so we can't enable that option.
1207 # So at least preclude common boolean strings as macro values.
1209 @prohibit
='^#define.*(yes|no|true|false)$$' \
1210 in_files
='$(CONFIG_INCLUDE)' \
1211 halt
='Use 0 or 1 for macro values' \
1212 $(_sc_search_regexp
)
1214 # Even if you use pathmax.h to guarantee that PATH_MAX is defined, it might
1215 # not be constant, or might overflow a stack. In general, use PATH_MAX as
1216 # a limit, not an array or alloca size.
1217 sc_prohibit_path_max_allocation
:
1218 @prohibit
='(\balloca *\([^)]*|\[[^]]*)PATH_MAX' \
1219 halt
='Avoid stack allocations of size PATH_MAX' \
1220 $(_sc_search_regexp
)
1222 sc_vulnerable_makefile_CVE-2009-4029
:
1223 @prohibit
='perm -777 -exec chmod a\+rwx|chmod 777 \$$\(distdir\)' \
1224 in_files
=(^\|
/)Makefile
\\.in
$$ \
1225 halt
=$$(printf
'%s\n' \
1226 'the above files are vulnerable; beware of running' \
1227 ' "make dist*" rules, and upgrade to fixed automake' \
1228 ' see http://bugzilla.redhat.com/542609 for details') \
1229 $(_sc_search_regexp
)
1231 sc_vulnerable_makefile_CVE-2012-3386
:
1232 @prohibit
='chmod a\+w \$$\(distdir\)' \
1233 in_files
=(^\|
/)Makefile
\\.in
$$ \
1234 halt
=$$(printf
'%s\n' \
1235 'the above files are vulnerable; beware of running' \
1236 ' "make distcheck", and upgrade to fixed automake' \
1237 ' see http://bugzilla.redhat.com/CVE-2012-3386 for details') \
1238 $(_sc_search_regexp
)
1241 (unset CDPATH
; cd
$(srcdir) && $(VC
) diff
) > vc-diffs ||
:
1242 if
test -s vc-diffs
; then \
1244 echo
"Some files are locally modified:" 1>&2; \
1250 rel-files
= $(DIST_ARCHIVES
)
1252 gnulib_dir ?
= $(srcdir)/gnulib
1253 gnulib-version
= $$(cd
$(gnulib_dir
) && git describe
)
1254 bootstrap-tools ?
= autoconf
,automake
,gnulib
1256 # If it's not already specified, derive the GPG key ID from
1257 # the signed tag we've just applied to mark this release.
1259 $$(git cat-file tag v
$(VERSION
) \
1260 | gpgv
--status-fd
1 --keyring
/dev
/null
- - 2>/dev
/null \
1261 | awk
'/^\[GNUPG:\] ERRSIG / {print $$3; exit}')
1263 translation_project_ ?
= coordinator@translationproject.org
1265 # Make info-gnu the default only for a stable release.
1266 ifeq ($(RELEASE_TYPE
),stable
)
1267 announcement_Cc_ ?
= $(translation_project_
), $(PACKAGE_BUGREPORT
)
1268 announcement_mail_headers_ ?
= \
1269 To
: info-gnu@gnu.org \
1270 Cc
: $(announcement_Cc_
) \
1271 Mail-Followup-To
: $(PACKAGE_BUGREPORT
)
1273 announcement_Cc_ ?
= $(translation_project_
)
1274 announcement_mail_headers_ ?
= \
1275 To
: $(PACKAGE_BUGREPORT
) \
1276 Cc
: $(announcement_Cc_
)
1279 announcement
: NEWS ChangeLog
$(rel-files
)
1280 @
$(srcdir)/$(_build-aux
)/announce-gen \
1281 --mail-headers
='$(announcement_mail_headers_)' \
1282 --release-type
=$(RELEASE_TYPE
) \
1283 --package
=$(PACKAGE
) \
1284 --prev
=$(PREV_VERSION
) \
1286 --gpg-key-id
=$(gpg_key_ID
) \
1287 --srcdir=$(srcdir) \
1288 --news
=$(srcdir)/NEWS \
1289 --bootstrap-tools
=$(bootstrap-tools
) \
1290 $$(case
,$(bootstrap-tools
), in
(*,gnulib
,*) \
1291 echo
--gnulib-version
=$(gnulib-version
);; esac
) \
1292 --no-print-checksums \
1293 $(addprefix --url-dir
=, $(url_dir_list
))
1295 ## ---------------- ##
1296 ## Updating files. ##
1297 ## ---------------- ##
1299 ftp-gnu
= ftp
://ftp.gnu.org
/gnu
1300 www-gnu
= http
://www.gnu.org
1302 upload_dest_dir_ ?
= $(PACKAGE
)
1303 emit_upload_commands
:
1304 @echo
=====================================
1305 @echo
=====================================
1306 @echo
"$(srcdir)/$(_build-aux)/gnupload $(GNUPLOADFLAGS) \\"
1307 @echo
" --to $(gnu_rel_host):$(upload_dest_dir_) \\"
1308 @echo
" $(rel-files)"
1309 @echo
'# send the ~/announce-$(my_distdir) e-mail'
1310 @echo
=====================================
1311 @echo
=====================================
1313 define emit-commit-log
1314 printf
'%s\n' 'maint: post-release administrivia' '' \
1315 '* NEWS: Add header line for next release.' \
1316 '* .prev-version: Record previous version.' \
1317 '* cfg.mk (old_NEWS_hash): Auto-update.'
1320 .PHONY
: no-submodule-changes
1321 no-submodule-changes
:
1322 if
test -d
$(srcdir)/.git
; then \
1323 diff
=$$(cd
$(srcdir) && git submodule
-q
foreach \
1324 git diff-index
--name-only HEAD
) \
1326 case
$$diff in
'') ;; \
1327 *) echo
'$(ME): submodule files are locally modified:'; \
1328 echo
"$$diff"; exit
1;; esac
; \
1333 submodule-checks ?
= no-submodule-changes public-submodule-commit
1335 # Ensure that each sub-module commit we're using is public.
1336 # Without this, it is too easy to tag and release code that
1337 # cannot be built from a fresh clone.
1338 .PHONY
: public-submodule-commit
1339 public-submodule-commit
:
1340 $(AM_V_GEN
)if
test -d
$(srcdir)/.git
; then \
1342 git submodule
--quiet
foreach test '$$(git rev-parse $$sha1)' \
1343 = '$$(git merge-base origin $$sha1)' \
1344 ||
{ echo
'$(ME): found non-public submodule commit' >&2; \
1349 # This rule has a high enough utility/cost ratio that it should be a
1350 # dependent of "check" by default. However, some of us do occasionally
1351 # commit a temporary change that deliberately points to a non-public
1352 # submodule commit, and want to be able to use rules like "make check".
1353 # In that case, run e.g., "make check gl_public_submodule_commit="
1354 # to disable this test.
1355 gl_public_submodule_commit ?
= public-submodule-commit
1356 check: $(gl_public_submodule_commit
)
1358 .PHONY
: alpha beta stable
1359 ALL_RECURSIVE_TARGETS
+= alpha beta stable
1360 alpha beta stable
: $(local-check
) writable-files
$(submodule-checks
)
1362 && { echo
$(VERSION
) | grep
-E
'^[0-9]+(\.[0-9]+)+$$' \
1363 ||
{ echo
"invalid version string: $(VERSION)" 1>&2; exit
1;};}\
1365 $(MAKE
) vc-diff-check
1369 $(MAKE
) $(release-prep-hook
) RELEASE_TYPE
=$@
1370 $(MAKE
) -s emit_upload_commands RELEASE_TYPE
=$@
1372 # Override this in cfg.mk if you follow different procedures.
1373 release-prep-hook ?
= release-prep
1375 gl_noteworthy_news_
= * Noteworthy changes in release ?.?
(????
-??
-??
) [?
]
1376 .PHONY
: release-prep
1378 case
$$RELEASE_TYPE in alpha|beta|stable
) ;; \
1379 *) echo
"invalid RELEASE_TYPE: $$RELEASE_TYPE" 1>&2; exit
1;; esac
1380 $(MAKE
) --no-print-directory
-s announcement
> ~
/announce-
$(my_distdir
)
1381 if
test -d
$(release_archive_dir
); then \
1382 ln
$(rel-files
) $(release_archive_dir
); \
1383 chmod a-w
$(rel-files
); \
1385 echo
$(VERSION
) > $(prev_version_file
)
1386 $(MAKE
) update-NEWS-hash
1387 perl
-pi
-e
'$$. == 3 and print "$(gl_noteworthy_news_)\n\n\n"' $(srcdir)/NEWS
1388 $(emit-commit-log
) > .ci-msg
1389 $(VC
) commit
-F .ci-msg
-a
1392 # Override this with e.g., -s $(srcdir)/some_other_name.texi
1393 # if the default $(PACKAGE)-derived name doesn't apply.
1398 @
test -z
"$(manual_title)" \
1399 && { echo
define manual_title in cfg.mk
1>&2; exit
1; } ||
:
1400 @cd
'$(srcdir)/doc'; \
1401 $(SHELL
) ..
/$(_build-aux
)/gendocs.sh
$(gendocs_options_
) \
1402 -o
'$(abs_builddir)/doc/manual' \
1403 --email
$(PACKAGE_BUGREPORT
) $(PACKAGE
) \
1404 "$(PACKAGE_NAME) - $(manual_title)"
1405 @echo
" *** Upload the doc/manual directory to web-cvs."
1410 $(MAKE
) $(AM_MAKEFLAGS
) clean
1411 lcov
--directory .
--zerocounters
1413 COVERAGE_CCOPTS ?
= "-g --coverage"
1414 COVERAGE_OUT ?
= doc
/coverage
1417 $(MAKE
) $(AM_MAKEFLAGS
) CFLAGS
=$(COVERAGE_CCOPTS
) CXXFLAGS
=$(COVERAGE_CCOPTS
)
1418 $(MAKE
) $(AM_MAKEFLAGS
) CFLAGS
=$(COVERAGE_CCOPTS
) CXXFLAGS
=$(COVERAGE_CCOPTS
) check
1419 mkdir
-p
$(COVERAGE_OUT
)
1420 lcov
--directory .
--output-file
$(COVERAGE_OUT
)/$(PACKAGE
).
info \
1424 genhtml
--output-directory
$(COVERAGE_OUT
) \
1425 $(COVERAGE_OUT
)/$(PACKAGE
).
info \
1426 --highlight
--frames
--legend \
1427 --title
"$(PACKAGE_NAME)"
1429 coverage
: init-coverage build-coverage gen-coverage
1431 # Update gettext files.
1432 PACKAGE ?
= $(shell basename $(PWD
))
1433 PO_DOMAIN ?
= $(PACKAGE
)
1434 POURL
= http
://translationproject.org
/latest
/$(PO_DOMAIN
)/
1437 rm -f
$(PODIR
)/*.po
&& \
1438 echo
"$(ME): getting translations into po (please ignore the robots.txt ERROR 404)..." && \
1439 wget
--no-verbose
--directory-prefix
$(PODIR
) --no-directories
--recursive
--level
1 --accept .po
--accept .po
.1 $(POURL
) && \
1440 echo
'en@boldquot' > $(PODIR
)/LINGUAS
&& \
1441 echo
'en@quot' >> $(PODIR
)/LINGUAS
&& \
1442 ls
$(PODIR
)/*.po | sed
's/\.po//;s,$(PODIR)/,,' |
sort >> $(PODIR
)/LINGUAS
1444 # Running indent once is not idempotent, but running it twice is.
1445 INDENT_SOURCES ?
= $(C_SOURCES
)
1448 indent
$(INDENT_SOURCES
)
1449 indent
$(INDENT_SOURCES
)
1451 # If you want to set UPDATE_COPYRIGHT_* environment variables,
1452 # put the assignments in this variable.
1453 update-copyright-env ?
=
1455 # Run this rule once per year (usually early in January)
1456 # to update all FSF copyright year lists in your project.
1457 # If you have an additional project-specific rule,
1458 # add it in cfg.mk along with a line 'update-copyright: prereq'.
1459 # By default, exclude all variants of COPYING; you can also
1460 # add exemptions (such as ChangeLog..* for rotated change logs)
1461 # in the file .x-update-copyright.
1462 .PHONY
: update-copyright
1464 grep
-l
-w Copyright \
1465 $$(export VC_LIST_EXCEPT_DEFAULT
=COPYING
&& $(VC_LIST_EXCEPT
)) \
1466 |
$(update-copyright-env
) xargs
$(srcdir)/$(_build-aux
)/$@
1468 # This tight_scope test is skipped with a warning if $(_gl_TS_headers) is not
1469 # overridden and $(_gl_TS_dir)/Makefile.am does not mention noinst_HEADERS.
1471 # NOTE: to override any _gl_TS_* default value, you must
1472 # define the variable(s) using "export" in cfg.mk.
1475 ALL_RECURSIVE_TARGETS
+= sc_tight_scope
1476 sc_tight_scope
: tight-scope.mk
1478 if
! grep
'^ *export _gl_TS_headers *=' $(srcdir)/cfg.mk \
1480 && ! grep
-w noinst_HEADERS
$(srcdir)/$(_gl_TS_dir
)/Makefile.am \
1481 > /dev
/null
2>&1; then \
1482 echo
'$(ME): skipping $@'; \
1484 $(MAKE
) -s
-C
$(_gl_TS_dir
) \
1486 -f
$(abs_top_srcdir
)/cfg.mk \
1487 -f
$(abs_top_builddir
)/$< \
1494 tight-scope.mk
: $(ME
)
1496 @perl
-ne
'/^# TS-start/.../^# TS-end/ and print' $(srcdir)/$(ME
) > $@
-t
1497 @chmod a
=r
$@
-t
&& mv
$@
-t
$@
1502 # Most functions should have static scope.
1503 # Any that don't must be marked with 'extern', but 'main'
1504 # and 'usage' are exceptions: they're always extern, but
1505 # do not need to be marked. Symbols matching '__.*' are
1506 # reserved by the compiler, so are automatically excluded below.
1507 _gl_TS_unmarked_extern_functions ?
= main usage
1508 _gl_TS_function_match ?
= /^
(?
:$(_gl_TS_extern
)) +.
*?
(\S
+) *\
(/
1510 # If your project uses a macro like "XTERN", then put
1511 # the following in cfg.mk to override this default:
1512 # export _gl_TS_extern = extern|XTERN
1513 _gl_TS_extern ?
= extern
1515 # The second nm|grep checks for file-scope variables with 'extern' scope.
1516 # Without gnulib's progname module, you might put program_name here.
1517 # Symbols matching '__.*' are reserved by the compiler,
1518 # so are automatically excluded below.
1519 _gl_TS_unmarked_extern_vars ?
=
1521 # NOTE: the _match variables are perl expressions -- not mere regular
1522 # expressions -- so that you can extend them to match other patterns
1523 # and easily extract matched variable names.
1524 # For example, if your project declares some global variables via
1525 # a macro like this: GLOBAL(type, var_name, initializer), then you
1526 # can override this definition to automatically extract those names:
1527 # export _gl_TS_var_match = \
1528 # /^(?:$(_gl_TS_extern)) .*?\**(\w+)(\[.*?\])?;/ || /\bGLOBAL\(.*?,\s*(.*?),/
1529 _gl_TS_var_match ?
= /^
(?
:$(_gl_TS_extern
)) .
*?
(\w
+)(\
[.
*?\
])?
;/
1531 # The names of object files in (or relative to) $(_gl_TS_dir).
1532 _gl_TS_obj_files ?
= *.
$(OBJEXT
)
1534 # Files in which to search for the one-line style extern declarations.
1535 # $(_gl_TS_dir)-relative.
1536 _gl_TS_headers ?
= $(noinst_HEADERS
)
1538 .PHONY
: _gl_tight_scope
1539 _gl_tight_scope
: $(bin_PROGRAMS
)
1540 t
=exceptions-
$$$$; \
1541 trap
's=$$?; rm -f $$t; exit $$s' 0; \
1542 for sig in
1 2 3 13 15; do \
1543 eval
"trap 'v=`expr $$sig + 128`; (exit $$v); exit $$v' $$sig"; \
1545 src
=`for f in $(SOURCES); do \
1546 test -f $$f && d= || d=$(srcdir)/; echo $$d$$f; done`; \
1547 hdr
=`for f in $(_gl_TS_headers); do \
1548 test -f $$f && d= || d=$(srcdir)/; echo $$d$$f; done`; \
1549 ( printf
'^%s$$\n' '__.*' $(_gl_TS_unmarked_extern_functions
); \
1550 grep
-h
-A1
'^extern .*[^;]$$' $$src \
1551 | grep
-vE
'^(extern |--)' | sed
's/ .*//'; \
1553 '$(_gl_TS_function_match) and print "^$$1\$$"' $$hdr; \
1554 ) |
sort -u
> $$t; \
1555 nm
-e
$(_gl_TS_obj_files
) | sed
-n
's/.* T //p'|grep
-Ev
-f
$$t \
1556 && { echo the above functions should have static scope
>&2; \
1558 ( printf
'^%s$$\n' '__.*' $(_gl_TS_unmarked_extern_vars
); \
1559 perl
-lne
'$(_gl_TS_var_match) and print "^$$1\$$"' $$hdr *.h \
1560 ) |
sort -u
> $$t; \
1561 nm
-e
$(_gl_TS_obj_files
) | sed
-n
's/.* [BCDGRS] //p' \
1562 |
sort -u | grep
-Ev
-f
$$t \
1563 && { echo the above variables should have static scope
>&2; \